package com.emr.service.ipml;

import com.emr.dao.TBasicBrowseHistoryMapper;
import com.emr.entity.Power_User;
import com.emr.entity.TBasicBrowseHistory;
import com.emr.util.IDHelper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.servlet.http.HttpServletRequest;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.Date;

/**
 * @ProjectName:
 * @Description:
 * @Param 传输参数
 * @Return
 * @Author: 曾文和
 * @CreateDate: 2022/2/10 22:30
 * @UpdateUser: 曾文和
 * @UpdateDate: 2022/2/10 22:30
 * @UpdateRemark: 更新说明
 * @Version: 1.0
 */
@Service
@Transactional
public class TBasicBrowseHistoryService {
    @Autowired
    private TBasicBrowseHistoryMapper tBasicBrowseHistoryMapper;

    public void insert(HttpServletRequest request,TBasicBrowseHistory tBasicBrowseHistory){
        try {
            long id = IDHelper.NewID();
            tBasicBrowseHistory.setId(id);
            tBasicBrowseHistory.setCreateTime(new Date());
            tBasicBrowseHistory.setIp(getIpAddr(request));
            tBasicBrowseHistoryMapper.insert(tBasicBrowseHistory);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static String getIpAddr(HttpServletRequest request) {
        String ipAddress = request.getHeader("x-forwarded-for");
        if (ipAddress == null || ipAddress.length() == 0 || "unknown".equalsIgnoreCase(ipAddress)) {
            ipAddress = request.getHeader("Proxy-Client-IP");
        }
        if (ipAddress == null || ipAddress.length() == 0 || "unknown".equalsIgnoreCase(ipAddress)) {
            ipAddress = request.getHeader("WL-Proxy-Client-IP");
        }
        if (ipAddress == null || ipAddress.length() == 0 || "unknown".equalsIgnoreCase(ipAddress)) {
            ipAddress = request.getRemoteAddr();
            String localIp = "127.0.0.1";
            String localIpv6 = "0:0:0:0:0:0:0:1";
            if (ipAddress.equals(localIp) || ipAddress.equals(localIpv6)) {
                // 根据网卡取本机配置的IP
                InetAddress inet = null;
                try {
                    inet = InetAddress.getLocalHost();
                    ipAddress = inet.getHostAddress();
                } catch (UnknownHostException e) {
                    e.printStackTrace();
                }
            }
        }
        // 对于通过多个代理的情况，第一个IP为客户端真实IP,多个IP按照','分割
        String ipSeparate = ",";
        int ipLength = 15;
        if (ipAddress != null && ipAddress.length() > ipLength) {
            if (ipAddress.indexOf(ipSeparate) > 0) {
                ipAddress = ipAddress.substring(0, ipAddress.indexOf(ipSeparate));
            }
        }
        return ipAddress;
    }
}
